﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap;

namespace Dimecasts.SOLID
{
    class Program
    {
       static Program()
       {
           ObjectFactory.Initialize( scanner =>
                                         {
                                             scanner.Scan( y =>
                                                               {
                                                                   y.TheCallingAssembly();
                                                                   y.WithDefaultConventions();
                                                               });


                                             scanner.ForRequestedType<ITabloidReport>()
                                                 .TheDefault.Is.OfConcreteType<TabloidReport>()
                                                 .CtorDependency<IReportPrinter>()
                                                 .Is(x =>
                                                         {
                                                             x.OfConcreteType<TabloidReportPrinter>()
                                                                 .CtorDependency<IReportFormatter>()
                                                                 .Is(y => y.OfConcreteType<TabloidReportFormatter>());
                                                         });
                                         }
                                         
                                         
                                         );
       }


        static void Main(string[] args)
        {
            var report = ObjectFactory.GetInstance<ITabloidReport>();
            //IReport report = new TabloidReport(new TabloidReportPrinter(new TabloidReportFormatter(), new ReportDataAccess()));

            report.Print();

            Console.WriteLine("\n\n\nProgram ended, hit any key to continue...");
            Console.ReadKey();
        }       


    }       
}
