using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Dimecasts.SOLID
{
    public interface ITabloidReport
    {
        void Print();
    }

    public class TabloidReport : Report, ITabloidReport
    {
        private IReportPrinter _reportPrinter;

        /// <summary>
        /// Initializes a new instance of the TabloidReport class.
        /// </summary>
        /// <param name="reportPrinter"></param>
        public TabloidReport(IReportPrinter reportPrinter)
        {
            _reportPrinter = reportPrinter;
        }

        public override void Print()
        {

            _reportPrinter.Print();

        }

    }
}
